Attribute VB_Name = "HDRoutines"
Option Explicit

'
'   D I S K    O P E R A T I O N S
'

' inserts organism file in the simulation
' remember that organisms could be made of more than one robot
Public Sub InsertOrganism(path As String)
  Dim x As Single, y As Single
  x = Random(Form1.ScaleLeft, Form1.ScaleWidth)
  y = Random(Form1.ScaleTop, Form1.ScaleHeight)
  LoadOrganism path, x, y
End Sub

' saves organism file
Public Sub SaveOrganism(path As String, r As Integer)
  Dim clist(50) As Integer
  Dim k As Integer, cnum As Integer
  k = 0
  clist(0) = r
  ListCells clist()
  While clist(cnum) > 0
    cnum = cnum + 1
  Wend
  Open path For Binary As 1
    Put #1, , cnum
    For k = 0 To cnum - 1
      SaveRobotBody 1, clist(k)
    Next k
  Close 1
End Sub

' loads an organism file
Public Sub LoadOrganism(path As String, x As Single, y As Single)
  Dim clist(50) As Integer
  Dim OList(50) As Integer
  Dim k As Integer, cnum As Integer
  Dim nuovo As Integer
  Open path For Binary As 1
    Get #1, , cnum
    For k = 0 To cnum - 1
      nuovo = posto()
      clist(k) = nuovo
      LoadRobot 1, nuovo
      rob(nuovo).pos.y = rob(nuovo).pos.y
    Next k
  Close 1
  If x > -1 And y > -1 Then
    PlaceOrganism clist(), x, y
  End If
  RemapTies clist(), OList, cnum
End Sub

' places an organism (made of robots listed in clist())
' in the specified x,y positions
Public Sub PlaceOrganism(clist() As Integer, x As Single, y As Single)
  Dim k As Integer
  Dim dx As Single, dy As Single
  dx = x - rob(clist(0)).pos.x
  dy = y - rob(clist(0)).pos.y
  While clist(k) > 0
    rob(clist(k)).pos.x = rob(clist(k)).pos.x + dx
    rob(clist(k)).pos.y = rob(clist(k)).pos.y + dy
    k = k + 1
    'UpdateBotBucket clist(k)
  Wend
End Sub

' remaps ties from the old index numbers - those the robots had
' when saved to disk- to the new indexes assigned in this simulation
Public Sub RemapTies(clist() As Integer, OList() As Integer, cnum As Integer)
  Dim t As Integer, ind As Integer, j As Integer, k As Integer
  For t = 0 To cnum - 1
    ind = OList(t)
    For k = 0 To cnum - 1
      j = 1
      While rob(clist(k)).Ties(j).pnt > 0
        If rob(clist(k)).Ties(j).pnt = ind Then
          rob(clist(k)).Ties(j).pnt = clist(t)
        End If
        j = j + 1
      Wend
    Next k
  Next t
End Sub

' saves a whole simulation
Public Sub SaveSimulation(path As String)
  Dim t As Integer
  Open path For Binary As 1
    
    Put #1, , MaxRobs
    
    For t = 1 To MaxRobs
      SaveRobotBody 1, t
    Next t
    
    Put #1, , CInt(Len(SimOpts.AutoRobPath))
    Put #1, , SimOpts.AutoRobPath
    Put #1, , SimOpts.AutoRobTime
    Put #1, , CInt(Len(SimOpts.AutoSimPath))
    Put #1, , SimOpts.AutoSimPath
    Put #1, , SimOpts.AutoSimTime
    Put #1, , SimOpts.BlockedVegs
    Put #1, , SimOpts.Costs(SHOTCOST)
    Put #1, , SimOpts.CostExecCond
    Put #1, , SimOpts.Costs(COSTSTORE)
    Put #1, , SimOpts.DBEnable
    Put #1, , SimOpts.DBExcludeVegs
    Put #1, , CInt(Len(SimOpts.DBName))
    Put #1, , SimOpts.DBName
    Put #1, , SimOpts.DBRecDna
    Put #1, , SimOpts.DisableTies
    Put #1, , SimOpts.EnergyExType
    Put #1, , SimOpts.EnergyFix
    Put #1, , SimOpts.EnergyProp
    Put #1, , SimOpts.FieldHeight
    Put #1, , SimOpts.FieldSize
    Put #1, , SimOpts.FieldWidth
    Put #1, , SimOpts.KillDistVegs
    Put #1, , SimOpts.MaxEnergy
    Put #1, , SimOpts.MaxPopulation
    Put #1, , SimOpts.MinVegs
    Put #1, , SimOpts.MutCurrMult
    Put #1, , SimOpts.MutCycMax
    Put #1, , SimOpts.MutCycMin
    Put #1, , SimOpts.MutOscill
    Put #1, , SimOpts.PhysBrown
    Put #1, , SimOpts.Ygravity
    Put #1, , SimOpts.Zgravity
    Put #1, , SimOpts.PhysMoving
    Put #1, , SimOpts.PhysSwim
    Put #1, , SimOpts.PopLimMethod
    Put #1, , CInt(Len(SimOpts.SimName))
    Put #1, , SimOpts.SimName
    Put #1, , SimOpts.SpeciesNum
    Put #1, , SimOpts.Toroidal
    Put #1, , SimOpts.TotBorn
    Put #1, , SimOpts.TotRunCycle
    Put #1, , SimOpts.TotRunTime
    
    'new stuff
    
    Put #1, , SimOpts.Pondmode
    Put #1, , SimOpts.KineticEnergy
    Put #1, , SimOpts.LightIntensity
    Put #1, , SimOpts.CorpseEnabled
    Put #1, , SimOpts.Decay
    Put #1, , SimOpts.Gradient
    Put #1, , SimOpts.DayNight
    Put #1, , SimOpts.CycleLength
    
    'new new stuff
    
    Put #1, , SimOpts.Decaydelay
    Put #1, , SimOpts.DecayType
    
    'obsolete
    Put #1, , SimOpts.Costs(MOVECOST)
    
    Put #1, , SimOpts.F1
    Put #1, , SimOpts.Restart
    
    'even even newer newer stuff
    Put #1, , SimOpts.Dxsxconnected
    Put #1, , SimOpts.Updnconnected
    Put #1, , SimOpts.RepopAmount
    Put #1, , SimOpts.RepopCooldown
    Put #1, , SimOpts.ZeroMomentum
    Put #1, , SimOpts.UserSeedNumber
    Put #1, , SimOpts.UserSeedToggle
    
    Put #1, , SimOpts.SpeciesNum
    
    Dim k As Integer
    For k = 0 To SimOpts.SpeciesNum
      Put #1, , SimOpts.Specie(k).Colind
      Put #1, , SimOpts.Specie(k).color
      Put #1, , CInt(Len(SimOpts.Specie(k).Comment))
      Put #1, , SimOpts.Specie(k).Comment
      Put #1, , SimOpts.Specie(k).Fixed
      Put #1, , CInt(Len(SimOpts.Specie(k).Leaguefilecomment))
      Put #1, , SimOpts.Specie(k).Leaguefilecomment
      Put #1, , SimOpts.Specie(k).Mutables.mutarray
      Put #1, , SimOpts.Specie(k).Mutables.Mutations
      Put #1, , CInt(Len(SimOpts.Specie(k).Name))
      Put #1, , SimOpts.Specie(k).Name
      
      'obsolete, so we do this instead
      'Put #1, , SimOpts.Specie(k).omnifeed
      Put #1, , 8
      
      Put #1, , CInt(Len(SimOpts.Specie(k).path))
      Put #1, , SimOpts.Specie(k).path
      Put #1, , SimOpts.Specie(k).Posdn
      Put #1, , SimOpts.Specie(k).Poslf
      Put #1, , SimOpts.Specie(k).Posrg
      Put #1, , SimOpts.Specie(k).Postp
      Put #1, , SimOpts.Specie(k).qty
      Put #1, , SimOpts.Specie(k).Skin
      Put #1, , SimOpts.Specie(k).Stnrg
      Put #1, , SimOpts.Specie(k).Veg
    Next k
    
    Put #1, , SimOpts.VegFeedingMethod
    Put #1, , SimOpts.VegFeedingToBody
    Put #1, , SimOpts.CoefficientStatic
    Put #1, , SimOpts.CoefficientKinetic
    Put #1, , SimOpts.PlanetEaters
    Put #1, , SimOpts.PlanetEatersG
    Put #1, , SimOpts.Viscosity
    Put #1, , SimOpts.Density
    
    'New for 2.4:
    For k = 0 To SimOpts.SpeciesNum
      Put #1, , SimOpts.Specie(k).Mutables.CopyErrorWhatToChange
      Put #1, , SimOpts.Specie(k).Mutables.PointWhatToChange
      
      Dim h As Integer
      
      For h = 0 To 20
        Put #1, , SimOpts.Specie(k).Mutables.Mean(h)
        Put #1, , SimOpts.Specie(k).Mutables.StdDev(h)
      Next h
      
      'Put #1, , SimOpts.p
    Next k
    
    For k = 0 To 70
      Put #1, , SimOpts.Costs(k)
    Next k
    
    'doesn't save shots!
    
  Close 1
End Sub

' loads a whole simulation
Public Sub LoadSimulation(path As String)
  'Because of the way that loadrobot and saverobot work, all save and load
  'sim routines are backwards and forwards compatible after 2.37.2
  '(not 2.37.2, but everything that comes after)
  Dim j As Integer
  Dim k As Integer
  
  For k = 0 To MaxRobs
    Erase rob(k).DNA()
    ReDim rob(k).DNA(1)
  Next k
  Erase rob()
  
  Open path For Binary As 1
    
    Get #1, , MaxRobs
    
    For k = 1 To MaxRobs
      LoadRobot 1, k
    Next k
    
    Get #1, , k: SimOpts.AutoRobPath = space(k)
    Get #1, , SimOpts.AutoRobPath
    Get #1, , SimOpts.AutoRobTime
    Get #1, , k: SimOpts.AutoSimPath = space(k)
    Get #1, , SimOpts.AutoSimPath
    Get #1, , SimOpts.AutoSimTime
    Get #1, , SimOpts.BlockedVegs
    Get #1, , SimOpts.Costs(SHOTCOST)
    Get #1, , SimOpts.CostExecCond
    Get #1, , SimOpts.Costs(COSTSTORE)
    Get #1, , SimOpts.DBEnable
    Get #1, , SimOpts.DBExcludeVegs
    Get #1, , k: SimOpts.DBName = space(k)
    Get #1, , SimOpts.DBName
    Get #1, , SimOpts.DBRecDna
    Get #1, , SimOpts.DisableTies
    Get #1, , SimOpts.EnergyExType
    Get #1, , SimOpts.EnergyFix
    Get #1, , SimOpts.EnergyProp
    Get #1, , SimOpts.FieldHeight
    Get #1, , SimOpts.FieldSize
    Get #1, , SimOpts.FieldWidth
    Get #1, , SimOpts.KillDistVegs
    Get #1, , SimOpts.MaxEnergy
    Get #1, , SimOpts.MaxPopulation
    Get #1, , SimOpts.MinVegs
    Get #1, , SimOpts.MutCurrMult
    Get #1, , SimOpts.MutCycMax
    Get #1, , SimOpts.MutCycMin
    Get #1, , SimOpts.MutOscill
    Get #1, , SimOpts.PhysBrown
    Get #1, , SimOpts.Ygravity
    Get #1, , SimOpts.Zgravity
    Get #1, , SimOpts.PhysMoving
    Get #1, , SimOpts.PhysSwim
    Get #1, , SimOpts.PopLimMethod
    Get #1, , k: SimOpts.SimName = space(k)
    Get #1, , SimOpts.SimName
    Get #1, , SimOpts.SpeciesNum
    Get #1, , SimOpts.Toroidal
    Get #1, , SimOpts.TotBorn
    Get #1, , SimOpts.TotRunCycle
    Get #1, , SimOpts.TotRunTime
    Get #1, , SimOpts.Pondmode
    Get #1, , SimOpts.KineticEnergy
    Get #1, , SimOpts.LightIntensity
    Get #1, , SimOpts.CorpseEnabled
    Get #1, , SimOpts.Decay
    Get #1, , SimOpts.Gradient
    Get #1, , SimOpts.DayNight
    Get #1, , SimOpts.CycleLength
    Get #1, , SimOpts.Decaydelay
    Get #1, , SimOpts.DecayType
    
    'obsolete
    Get #1, , SimOpts.Costs(MOVECOST)
    
    Get #1, , SimOpts.F1
    Get #1, , SimOpts.Restart
    
    'newer stuff
    If Not EOF(1) Then Get #1, , SimOpts.Dxsxconnected
    If Not EOF(1) Then Get #1, , SimOpts.Updnconnected
    If Not EOF(1) Then Get #1, , SimOpts.RepopAmount
    If Not EOF(1) Then Get #1, , SimOpts.RepopCooldown
    If Not EOF(1) Then Get #1, , SimOpts.ZeroMomentum
    If Not EOF(1) Then Get #1, , SimOpts.UserSeedNumber
    If Not EOF(1) Then Get #1, , SimOpts.UserSeedToggle
    
    If Not EOF(1) Then Get #1, , SimOpts.SpeciesNum
    
    For k = 0 To SimOpts.SpeciesNum
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Colind
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).color
      If Not EOF(1) Then Get #1, , j: SimOpts.Specie(k).Comment = space(j)
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Comment
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Fixed
      If Not EOF(1) Then Get #1, , j: SimOpts.Specie(k).Leaguefilecomment = space(j)
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Leaguefilecomment
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Mutables.mutarray
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Mutables.Mutations
      If Not EOF(1) Then Get #1, , j: SimOpts.Specie(k).Name = space(j)
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Name
      
      'obsolete
      'If Not EOF(1) Then Get #1, , SimOpts.Specie(k).omnifeed
      If Not EOF(1) Then Get #1, , j
      
      If Not EOF(1) Then Get #1, , j: SimOpts.Specie(k).path = space(j)
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).path
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Posdn
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Poslf
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Posrg
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Postp
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).qty
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Skin
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Stnrg
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Veg
    Next k
    
    If Not EOF(1) Then Get #1, , SimOpts.VegFeedingMethod
    If Not EOF(1) Then Get #1, , SimOpts.VegFeedingToBody
    
    'New for 2.4
    If Not EOF(1) Then Get #1, , SimOpts.CoefficientStatic
    If Not EOF(1) Then Get #1, , SimOpts.CoefficientKinetic
    If Not EOF(1) Then Get #1, , SimOpts.PlanetEaters
    If Not EOF(1) Then Get #1, , SimOpts.PlanetEatersG
    If Not EOF(1) Then Get #1, , SimOpts.Viscosity
    If Not EOF(1) Then Get #1, , SimOpts.Density
    
    For k = 0 To SimOpts.SpeciesNum
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Mutables.CopyErrorWhatToChange
      If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Mutables.PointWhatToChange
      
      For j = 0 To 20
        If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Mutables.Mean(j)
        If Not EOF(1) Then Get #1, , SimOpts.Specie(k).Mutables.StdDev(j)
      Next j
    Next k
    
    For k = 0 To 70
      If Not EOF(1) Then Get #1, , SimOpts.Costs(k)
    Next k
  Close 1
End Sub

' loads a single robot
Public Sub LoadRobot(fnum As Integer, n As Integer)
  LoadRobotBody 1, n
  If rob(n).Exist Then
    GiveAbsNum n
    insertsysvars n
    ScanUsedVars n
    makeoccurrlist n
    rob(n).DnaLen = DnaLen(rob(n).DNA())
    'UpdateBotBucket n
  End If
End Sub

' assignes a robot his unique code
Private Sub GiveAbsNum(k As Integer)
  Dim n As Integer, max As Long
  For n = 1 To MaxRobs
    If max < rob(n).AbsNum Then
      max = rob(n).AbsNum
    End If
  Next n
  rob(k).AbsNum = max + 1
End Sub

' saves a single robot
Public Sub SaveRobot(n As Integer, path As String)
  Open path For Binary As 1
    SaveRobotBody 1, n
  Close 1
End Sub
' loads the body of the robot
Private Sub LoadRobotBody(n As Integer, r As Integer)
'robot r
'file #n,
  Dim t As Integer, k As Integer, ind As Integer, Fe As Byte
  With rob(r)
  
    Get #n, , .Veg
    Get #n, , .Wall
    Get #n, , .Fixed
    
    Get #n, , .pos.x
    Get #n, , .pos.y
    Get #n, , .vel.x
    Get #n, , .vel.y
    Get #n, , .aim
    Get #n, , .ma           'momento angolare
    Get #n, , .mt           'momento torcente
     
    'ties
    For t = 0 To 10
      Get #n, , .Ties(t).Port
      Get #n, , .Ties(t).pnt
      Get #n, , .Ties(t).ptt
      Get #n, , .Ties(t).ang
      Get #n, , .Ties(t).bend
      Get #n, , .Ties(t).angreg
      Get #n, , .Ties(t).ln
      Get #n, , .Ties(t).shrink
      Get #n, , .Ties(t).stat
      Get #n, , .Ties(t).last
      Get #n, , .Ties(t).mem
      Get #n, , .Ties(t).back
      Get #n, , .Ties(t).nrgused
      Get #n, , .Ties(t).infused
      Get #n, , .Ties(t).sharing
    Next t
    
    Get #n, , .nrg:
    
    For t = 1 To 50
      Get #n, , k: .vars(t).Name = space(k)
      Get #n, , .vars(t).Name   '|
      Get #n, , .vars(t).value
    Next t
    Get #n, , .vnum             '| variabili private
    
    ' macchina virtuale
    Get #n, , .mem()       ' memoria dati
    Get #n, , k: ReDim .DNA(k)
    
    For t = 1 To k
      Get #n, , .DNA(t).tipo
      Get #n, , .DNA(t).value
    Next t
        
    For t = 0 To 20
      Get #n, , .Mutables.mutarray(t)
    Next t
    
    ' informative
    Get #n, , .SonNumber
    Get #n, , .Mutations
    Get #n, , .LastMut
    Get #n, , .parent
    Get #n, , .age
    Get #n, , .BirthCycle
    Get #n, , .genenum
    Get #n, , .generation
    Get #n, , .DnaLen
    
    ' aspetto
    Get #n, , .Skin()
    Get #n, , .color
    
    'new stuff using FileContinue conditions for backward and forward compatability
    If FileContinue(1) Then Get #n, , .BODY: .radius = FindRadius(.BODY)
    If FileContinue(1) Then Get #n, , .Bouyancy
    If FileContinue(1) Then Get #n, , .Corpse
    If FileContinue(1) Then Get #n, , .Pwaste
    If FileContinue(1) Then Get #n, , .Waste
    If FileContinue(1) Then Get #n, , .poison
    If FileContinue(1) Then Get #n, , .venom
    If FileContinue(1) Then Get #n, , .Shape
    If FileContinue(1) Then Get #n, , .Exist
    If FileContinue(1) Then Get #n, , .Dead
    
    If FileContinue(1) Then Get #1, , k: .fname = space(k)
    If FileContinue(1) Then Get #1, , .fname
    
    If FileContinue(1) Then Get #1, , k: .LastOwner = space(k)
    If FileContinue(1) Then Get #1, , .LastOwner
    
    If FileContinue(1) Then Get #1, , k: .LastMutDetail = space(k)
    If FileContinue(1) Then Get #1, , .LastMutDetail
    
    If FileContinue(1) Then Get #1, , .Mutables.Mutations
    
    For t = 0 To 20
      If FileContinue(1) Then Get #1, , .Mutables.Mean(t)
      If FileContinue(1) Then Get #1, , .Mutables.StdDev(t)
    Next t
    
    If FileContinue(1) Then Get #1, , .Mutables.CopyErrorWhatToChange
    If FileContinue(1) Then Get #1, , .Mutables.PointWhatToChange
    
    'read in any future data here
    
    'burn through any new data from a different version
    While FileContinue(1)
      Get #1, , Fe
    Wend
    
    'grab these three FE codes
    Get #1, , Fe
    Get #1, , Fe
    Get #1, , Fe
    
    'don't you dare put anything after this!
  End With
End Sub

Private Function FileContinue(filenumber As Integer) As Boolean
  'three FE bytes (ie: 254) means we are at the end of the record
  
  Dim Fe As Byte
  Dim Position As Long
  Dim k As Integer
  
  FileContinue = False
  Position = Seek(1)
   
  Do
    If Not EOF(1) Then
      Get #1, , Fe
    Else
      FileContinue = False
      Fe = 254
    End If
    
    k = k + 1
    
    If Fe <> 254 Then
      FileContinue = True
      'exit immediatly, we are done
    End If
  Loop While Not FileContinue And k < 3
  
  'reset position
  Get #1, Position - 1, Fe
End Function
' saves the body of the robot
Private Sub SaveRobotBody(n As Integer, r As Integer)
  Dim t As Integer, k As Integer
  Const Fe As Byte = 254
  Dim space As Integer
  With rob(r)
    
    Put #n, , .Veg
    Put #n, , .Wall
    Put #n, , .Fixed
    
    ' fisiche
    Put #n, , .pos.x
    Put #n, , .pos.y
    Put #n, , .vel.x
    Put #n, , .vel.y
    Put #n, , .aim
    Put #n, , .ma           'momento angolare
    Put #n, , .mt           'momento torcente
    
    For t = 0 To 10
      Put #n, , .Ties(t).Port
      Put #n, , .Ties(t).pnt
      Put #n, , .Ties(t).ptt
      Put #n, , .Ties(t).ang
      Put #n, , .Ties(t).bend
      Put #n, , .Ties(t).angreg
      Put #n, , .Ties(t).ln
      Put #n, , .Ties(t).shrink
      Put #n, , .Ties(t).stat
      Put #n, , .Ties(t).last
      Put #n, , .Ties(t).mem
      Put #n, , .Ties(t).back
      Put #n, , .Ties(t).nrgused
      Put #n, , .Ties(t).infused
      Put #n, , .Ties(t).sharing
    Next t
    
    ' biologiche
    Put #n, , .nrg
    
    'custom variables we're saving
    For t = 1 To 50
      Put #n, , CInt(Len(.vars(t).Name))
      Put #n, , .vars(t).Name         '|
      Put #n, , .vars(t).value
    Next t

    Put #n, , .vnum            '| variabili private
    
    ' macchina virtuale
    Put #n, , .mem()
    k = DnaLen(rob(r).DNA()): Put #n, , k
    For t = 1 To k
      Put #n, , .DNA(t).tipo
      Put #n, , .DNA(t).value
    Next t
    
    For t = 0 To 20
      Put #n, , .Mutables.mutarray(t)
    Next t
    
    ' informative
    Put #n, , .SonNumber
    Put #n, , .Mutations
    Put #n, , .LastMut
    Put #n, , .parent
    Put #n, , .age
    Put #n, , .BirthCycle
    Put #n, , .genenum
    Put #n, , .generation
    Put #n, , .DnaLen
    
    ' aspetto

    Put #n, , .Skin()
    Put #n, , .color
    
    ' new features
    Put #n, , .BODY
    Put #n, , .Bouyancy
    Put #n, , .Corpse
    Put #n, , .Pwaste
    Put #n, , .Waste
    Put #n, , .poison
    Put #n, , .venom
    Put #n, , .Shape
    Put #n, , .Exist
    Put #n, , .Dead
    
    Put #n, , CInt(Len(.fname))
    Put #n, , .fname
    
    Put #n, , CInt(Len(.LastOwner))
    Put #n, , .LastOwner
    
    Put #n, , CInt(Len(.LastMutDetail))
    Put #n, , .LastMutDetail
    
    For t = 0 To 20
      Put #n, , .Mutables.Mean(t)
      Put #n, , .Mutables.StdDev(t)
    Next t
    
    Put #n, , .Mutables.CopyErrorWhatToChange
    Put #n, , .Mutables.PointWhatToChange
    
    'write any future data here
    
    Put #n, , Fe
    Put #n, , Fe
    Put #n, , Fe
  End With
End Sub

' saves a robot dna     !!!New routine from Carlo!!!
Sub salvarob(n As Integer, path As String, Optional nombox As Boolean)
  Dim t As Integer
  Dim a As String
  Dim ti As Byte
  Dim va As Integer
  Dim hold As String
  Dim hashed As String
  t = 1
  Open path For Output As #1
  hold = SaveRobHeader(n)
  hold = hold + DetokenizeDNA(n)
  hashed = Hash(hold, 20)
  Print #1, hold
  Print #1, ""
  Print #1, "'#hash: " + hashed
  Close #1
  If Not nombox Then
    If MsgBox("Do you want to change robot's name to " + extractname(path) + " ?", vbYesNo, "Robot DNA saved") = vbYes Then
      rob(n).fname = extractname(path)
    End If
  End If
End Sub

Public Function Load_League_File(Leaguename As String) As Integer
'returns -1 if league doesn't exist,
'0 if successful,
'[1-30] if a robot in the list doesn't exist
'-2 if leaguefile exists but not directory
'-3 if leaguefile contains too many entrants
'-4 if leaguefile contains too few entrants
'-5 if leaguefile contains an unknown error
  Dim filename As String
  Dim Line As String
  Dim singlecharacter As String
  Dim currpos As Long
  Dim robotname As String
  Dim robotcomment As String
  Dim length As Long
 
  filename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt"
  
  On Error GoTo Nosuchfile
  Open filename For Input As 1
    
  Line Input #1, Line
  Line = Line + "'"
  currpos = 1
  singlecharacter = Mid(Line, currpos, 1)
  
  On Error GoTo invalidfile
  While True
    While singlecharacter <> "#"
      If singlecharacter = "1" Then
        If Left(Line, 3) = "1 -" Then
          'start of robot list, exit physics loop
          GoTo endloop
        End If
      End If
      
      currpos = currpos + 1
      If singlecharacter = "'" Then
        Line Input #1, Line
        currpos = 1
        singlecharacter = Mid(Line, currpos, 1)
      End If
    Wend
    
    'we now have the pos of a physics line
    If Mid(Line, currpos, 3) = "#F1" Then
      SimOpts.F1 = True
      SimOpts.CorpseEnabled = False
      SimOpts.Costs(SHOTCOST) = 2
      SimOpts.CostExecCond = 0.004
      SimOpts.Costs(COSTSTORE) = 0.04
      SimOpts.DayNight = False
      SimOpts.FieldWidth = 9237
      SimOpts.FieldHeight = 6928
      SimOpts.FieldSize = 1
      SimOpts.MaxEnergy = 40
      SimOpts.MaxPopulation = 25
      SimOpts.MinVegs = 10
      SimOpts.Pondmode = False
      SimOpts.PhysBrown = 0
      SimOpts.Toroidal = True
    Else
      'custom physics.
    End If
    
    Line Input #1, Line
    singlecharacter = Mid(Line, currpos, 1)
  Wend
endloop:
  
  'we are now at the start of the robot declaration list.  Add these robots to
  'the league table
  Dim Index As Integer
  
  For Index = 0 To 30
    filename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\" 'directory of league robots
    Line = Line + "'"
    
    length = InStr(Line, "'") - 1
    If Right(Left(Line, length), 1) = " " Then length = length - 1
    robotname = Left(Line, length)
    robotcomment = Right(Line, Len(Line) - length)
    robotcomment = Left(robotcomment, Len(robotcomment) - 1)
    robotname = Right(robotname, Len(robotname) - 4) 'takes everything besides teh "1 - " at start of line and " 'blah..." at end of line
    If robotname = "EMPTY" Or robotname = "" Then
      Add_Blank_Specie Index
    Else
      robotname = filename + robotname + ".txt" 'now we have the path and filename of the robot
      'add robot robotname to LeagueEntrants array
      Add_Specie robotname, Index, robotcomment
    End If
    
    If EOF(1) Then GoTo endloop2
    
    Line Input #1, Line
  Next Index
endloop2:
  
  Index = Index + 1
  'write emptys to the rest of the array
  For Index = Index To 30
    Add_Blank_Specie Index
  Next Index
  
  Close_League_File
  Load_League_File = 0
  Exit Function
  
Nosuchfile:
  Close_League_File
  MsgBox filename + " doesn't exist.", vbOKOnly, "League File Not Found"
  Load_League_File = -1
  Exit Function
invalidfile:
  Close_League_File
  MsgBox "Error reading from " + filename + ".  Abandoning attempt.", vbOKOnly, "File Reading Error"
  Load_League_File = -5
  Exit Function
End Function

Public Sub Close_League_File()
  Close 1
End Sub

Private Sub Add_Specie(path As String, k As Integer, leaguecomment As String)
  LeagueEntrants(k).Posrg = Form1.Width
  LeagueEntrants(k).Posdn = Form1.Height
  LeagueEntrants(k).Poslf = 0
  LeagueEntrants(k).Postp = 0
  LeagueEntrants(k).Name = extractname(path)
  LeagueEntrants(k).path = extractpath(path)
  LeagueEntrants(k).path = relpath(LeagueEntrants(k).path)
  LeagueEntrants(k).Veg = False
  LeagueEntrants(k).color = vbBlue
  Dim t As Integer
  LeagueEntrants(k).Mutables.Mutations = False
  'For t = 0 To 15
  '  LeagueEntrants(k).mutarray(t) = 0
  'Next t
  LeagueEntrants(k).qty = 5
  LeagueEntrants(k).Stnrg = 3000
  LeagueEntrants(k).Fixed = False
  
  Dim i As Integer
  For i = 0 To 7 Step 2
    LeagueEntrants(k).Skin(i) = Random(0, half)
    LeagueEntrants(k).Skin(i + 1) = Random(0, 628)
  Next i
  
  LeagueEntrants(k).Leaguefilecomment = leaguecomment
End Sub

Private Sub Add_Blank_Specie(k As Integer)
  Dim Specie As datispecie
   
  LeagueEntrants(k) = Specie
End Sub

Public Function Save_League_File(Name As String) As Integer
  Dim filename As String
  Dim tofilename As String
  Dim Line As String
  Dim singlecharacter As String
  Dim currpos As Long
  Dim robotname As String
  Dim length As Long
  Dim loopdone As Boolean
  Dim originalleague As Boolean
 
  filename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt"
  tofilename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.tmp"
    
  On Error GoTo Nosuchfile
  Open filename For Input As 1
enderror:
   
  On Error GoTo Problem
  Open tofilename For Output As 2
    
  If originalleague = False Then
    Line Input #1, Line
    If Left(Line, 4) = "1 - " Then loopdone = True
    While Not loopdone And Not EOF(1)
      Print #2, Line
      Line Input #1, Line
      If Left(Line, 4) = "1 - " Then loopdone = True
    Wend
  Else
    Line = "'New league created by program."
    Print #2, Line
    Line = "#F1"
    Print #2, Line
  End If
  
  'now we write robot data
  
  If dir$(MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\*.*") = "" Then
    MkDir MDIForm1.MainDir + "\Leagues\" + Leaguename + "league"
  End If
  
  Dim Index As Integer
  For Index = 1 To 9
    Line = Index
    Line = Line + " - "
    If LeagueEntrants(Index - 1).Name = "" Then LeagueEntrants(Index - 1).Name = "EMPTY.TXT"
    Line = Line + Left(LeagueEntrants(Index - 1).Name, Len(LeagueEntrants(Index - 1).Name) - 4)
    Line = Line + LeagueEntrants(Index - 1).Leaguefilecomment
    Print #2, Line
    
    If Not LeagueEntrants(Index - 1).Name = "EMPTY.TXT" Then
      'if this robot doesn't exist in the league directory, copy its file to the league directory
      If dir$(MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\" + LeagueEntrants(Index - 1).Name) = "" And LeagueEntrants(Index - 1).Name <> "" Then
        Dim tempstring As String
      
        tempstring = LeagueEntrants(Index - 1).path + "\" + LeagueEntrants(Index - 1).Name
        If (Left(tempstring, 2) = "&#") Then
          tempstring = MDIForm1.MainDir + Right(tempstring, Len(tempstring) - 2)
        End If
        If dir$(tempstring) <> "" Then
          FileCopy tempstring, MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\" + LeagueEntrants(Index - 1).Name
        Else
          MsgBox "Error copying " + LeagueEntrants(Index - 1).path + "\" + LeagueEntrants(Index - 1).Name + " into league directory.  Continuing...", vbOKOnly, "Copy File Error"
        End If
      End If
    End If
  Next Index
  
  For Index = 10 To 30
    Line = Index
    Line = Line + "- "
    If LeagueEntrants(Index - 1).Name = "" Then LeagueEntrants(Index - 1).Name = "EMPTY.TXT"
    Line = Line + Left(LeagueEntrants(Index - 1).Name, Len(LeagueEntrants(Index - 1).Name) - 4)
    Line = Line + LeagueEntrants(Index - 1).Leaguefilecomment
    Print #2, Line
  Next Index
  
  Close #1
  Close #2
  
  If dir$(MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.bak") = " " Then
    Kill MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.bak"
  End If
  
  'move leaguetable.txt to leaguetable.bak.
  If Not originalleague Then
    Name MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt" As MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.bak"
  End If
  
  'replace leaguetable.txt with leaguetable.tmp
  Name MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.tmp" As MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt"
  
  Exit Function
  
Nosuchfile:
  Close #1
  originalleague = True
  GoTo enderror
  
Problem:
  Close #1
  Close #2
  MsgBox "Error writing to " + MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.tmp.  Abandoning save attempt.", vbOKOnly, "Save file error"
  Save_League_File = -1
  Exit Function
End Function
